/*

	ASSEMBLER

*/

#include <ctype.h>
#include <string.h>
#include <dos.h>

extern unsigned PrevedHexa( char );

extern "C" unsigned char far *PRAM;
extern "C" unsigned char in_bas[];
extern "C" unsigned char in_dd_fd[];

char cmps[60];		// hledana instrukce
unsigned int AssPC;	// tam se ma ulozit vysledek
int DDFD;		// instrukce DD nebo FD ?
int DD;			// DD ?
int Codes[8];		// kod instrukce
unsigned int CoPtr[4];	// pointery na kody
int CodesPtr;		// ukazatel do kodu instrukci
int iSize;		// velikost instrukce
unsigned int PCAA;	// kam se ma instrukce ulozit
int errAdr;		// chybna adresa

unsigned int DecodeAdress1( const char s[], int &p )
{
  int s1 = s[0] == '-';
  if (s[0] == '+') s1++;
  if ( (s[s1] < '0') || (s[s1] > '9') ) return 0x100;
  int i = 0;
  while ( (s[i+s1] != 0) &&
	  ( ((s[i+s1] >= '0') && (s[i+s1] <= '9')) ||
	    ((s[i+s1] >= 'A') && (s[i+s1] <= 'F')) )) i++;
  p += s1+i--;
  int Result = 0;
  if ( i >= 0 )
    Result = PrevedHexa( s[s1+i--] );
  if ( i >= 0 )
    Result |= PrevedHexa( s[s1+i--] ) << 4;
  if (s[0] == '-') Result = -Result;
  if (Result < -0x7f) return 0x100;
  if (Result > 0x80) return 0x100;
  return Result;
}

unsigned int DecodeAdress( const char s[], int &p )
{
  if ( (s[0] < '0') || (s[0] > '9') )
    {
      errAdr = 1;
      return 0;
    }
  int i = 0;
  while ( (s[i] != 0) &&
	  ( ((s[i] >= '0') && (s[i] <= '9')) ||
	    ((s[i] >= 'A') && (s[i] <= 'F')) )) i++;
  p += i--;
  unsigned Result = 0;
  if ( i >= 0 )
    Result = PrevedHexa( s[i--] );
  if ( i >= 0 )
    Result |= PrevedHexa( s[i--] ) << 4;
  if ( i >= 0 )
    Result |= PrevedHexa( s[i--] ) << 8;
  if ( i >= 0 )
    Result |= PrevedHexa( s[i--] ) << 12;
  errAdr = 0;
  return Result;
}

int CompareInstr( const char in[] )
{
  char in1 [60];
  int i;
  int p;
  int &x = p;
  p = 0;
  for (i = 1; in[i] != 0; i++)
    if ( (in[i] != ' ') && (in[i] != 9) )
      in1[p++] = in[i];
  in1[p] = 0;
  unsigned int a;
  p = 0;
  iSize = CodesPtr + 1;
  for (i = 0; in1[i] != 0; i++)
    {
      if ( in1[i] < ' ' )
	switch ( in1[i] ) {
	  case 1: { a = DecodeAdress( &cmps[p], x );
		    if ( errAdr ) return 0;
		    if ( PCAA + 2 > a )
		      {
			if ( PCAA + 2 - a > 0x7f ) return 0;
			Codes[iSize++] = 0x100 - (PCAA + 2 - a);
		      }
		     else
		      {
			if ( a - (PCAA + 2) > 0x80 ) return 0;
			Codes[iSize++] = a - (PCAA + 2);
		      }
		    break;
		  }
	  case 2: { a = DecodeAdress( &cmps[p], x );
		    if ( errAdr ) return 0;
		    Codes[iSize++] = a & 0xff;
		    Codes[iSize++] = (a >> 8) & 0xff;
		    break;
		  }
	  case 3: { a = DecodeAdress( &cmps[p], x );
		    if ( errAdr ) return 0;
		    if ( a > 0x100 ) return 0;
		    Codes[iSize++] = a; break;
		  }
	  case 4: { a = DecodeAdress( &cmps[p], x );
		    if ( errAdr ) return 0;
		    Codes[iSize++] = a & 0xff;
		    Codes[iSize++] = (a >> 8) & 0xff; break;
		  }
	  case 5: { a = *(int *)&cmps[p];
		    if ( (a != 'IX') && (a != 'IY') ) return 0;
		    p += 2; break;
		  }
	  case 6: { a = *(int *)&cmps[p];
		    if ( (a != 'XH') && (a != 'YH') ) return 0;
		    p += 2; break;
		  }
	  case 7: { a = *(int *)&cmps[p];
		    if ( (a != 'XL') && (a != 'YL') ) return 0;
		    p += 2; break;
		  }
	  case 8: { a = DecodeAdress1( &cmps[p], x );
		    if ( a == 0x100 ) return 0;
		    Codes[iSize++] = a; break;
		  }
	}
       else
	if ( cmps[p++] != in1[i] ) return 0;
    }
  return (cmps[p] == 0);
}

int AssembleI( const char in[] )
{
  char near *Instr;
  CoPtr[0] = FP_OFF(in);
  CodesPtr = 0; Codes[0] = -1;
  while ( CodesPtr >= 0 )
    {
      Codes[CodesPtr]++;
      while ( Codes[CodesPtr] < 256 )
	{
	  (int)Instr = CoPtr[CodesPtr] + (Codes[CodesPtr] << 1);
	  Instr = (char near *)*(unsigned int *)Instr;
	  if ( (unsigned char)Instr[0] != 0xff )
	    {
	      if ( Instr[0] & 0x20 )	// prefix, nasleduje dalsi tbl
		{
		  CodesPtr++;
		  CoPtr[CodesPtr] = FP_OFF(&Instr[1]);
		  Codes[CodesPtr] = 0;
		  CodesPtr++;
		  break;
		}
	      if ( CompareInstr( Instr ) ) return 0;
	    }
	  Codes[CodesPtr]++;
	}
      CodesPtr--;
    }
  return -1;
}

int decodeBytes()
{
  int p = 2;
  int &xx = p;
  unsigned x;
  CodesPtr = 0;
  do {
    x = DecodeAdress( &cmps[p], xx );
    if ( errAdr ) return -1;
    Codes[CodesPtr++] = x;
  } while ( cmps[p++] == ',' );
  for (p = 0; p < CodesPtr; p++)
    PRAM[ PCAA + p ] = Codes[p];
  return CodesPtr;
}

int Assembler( const char s[], unsigned int PC )
{
  PCAA = PC;
  strcpy(cmps, s);
  int c = 0;
  int i;
  for (i = 0; cmps[i] != 0; i++)
    if ( (cmps[i] != ' ') && (cmps[i] != 9) ) cmps[c++] = toupper(cmps[i]);
  cmps[c] = 0;
  if ( *(int*)&cmps[0] == 'B=' ) return decodeBytes();
  DDFD = 0;
  DD = 0;
  for (i = 0; i < c - 1; i++)
    {
      unsigned int XX;
      XX = *(int *)&cmps[i];
      if ( (XX == 'IX') || (XX == 'IY') || (XX == 'XH') || (XX == 'YH') ||
	   (XX == 'XL') || (XX == 'YL') )
	{
	  DDFD = 1;
	  if ( DD && ((XX == 'IY') || (XX == 'YH') || (XX == 'YL')) )
						 return -1;
	  if ( !DD ) DD = (XX == 'IX') || (XX == 'XH') || (XX == 'XL');
	}
    }
  if ( DDFD )
    {
      if ( AssembleI( in_dd_fd ) < 0 ) return -1;
    }
   else
    if ( AssembleI( in_bas ) < 0 ) return -1;
  if ( DDFD )
    if ( DD ) PRAM[PC++] = 0xdd;
      else PRAM[PC++] = 0xfd;
  if ( (Codes[0] == 0xcb) && DDFD )
    {
      i = Codes[1]; Codes[1] = Codes[2]; Codes[2] = i;
    }
  for (i = 0; i < iSize; i++)
    {
      PRAM[PC + i] = Codes[i];
    }
  return iSize + DDFD;
}
