#include <ctype.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>

extern char emulDirectory[78];
extern void WaitStatusLine(char s[]);
extern "C" setupCfg( void far * );

int cfgHandle;
int cfgEnd;			// konec souboru ?
char cfgLine[40];		// radka z konfiguracniho souboru

struct cfgType {
char name[10];			// max 10 znaku
void far *p;			// pointer
char type;			// typ
};

char cfgDrive = 0;		// neprohozeno ...
char cfgMusic = 0;		// zakazana
int  cfgFreq  = 16000;		// asi jo ...
char cfgRD    = 1;		// ram disk je povoleny
int  cfgLPT   = 1;		// cislo tiskarny
int  cfgHrdwr = 0;		// hardware pro hudbu
char cfgS256  = 0;		// normalni CP/M
char cfgVGA   = 0;		// normalni barvy


cfgType cfgs[] =
{ { "drive", &cfgDrive, 1 },	// 0 = neprohozeno, 1 = A: <=> B:
  { "amusic", &cfgMusic, 1 },	// 0 = zakazana hudba z amigy, 1 = povolena
  { "afreq", &cfgFreq, 2 },	// frekvence v Hz
  { "ramdrive", &cfgRD, 1 },	// 0 = zakazany 512kB ram disk, 1 = povoleny
  { "lpt", &cfgLPT, 2 },	// cislo tiskarny 1 - 4
  { "hrdwr", &cfgHrdwr, 2 },	// hardware
  { "s256", &cfgS256, 1 },	// 0 = normalni CP/M; 1 = 256 byte na sec.
  { "vgacol", &cfgVGA, 1 }, 	// 0 = od 16 barvy; 1 = od 8 barvy
  { "", NULL, 0 }
};

void readCfgLine()
{
  int ptr = 0;
  do {
    cfgEnd = read( cfgHandle, &cfgLine[ptr], 1 ) != 1;
  } while ( (cfgLine[ptr++] != 0x0a) && (!cfgEnd) );
  if ( cfgEnd ) ptr--;
  cfgLine[ ptr ] = 0;
}

void decodeCfgLine()
{
  int ptr;
  int ptrC = 0;
  int ok = 0;
  while ( cfgs[ ptrC ]. p != NULL )
    {
      ptr = 0;
      while ( tolower(cfgLine[ptr]) == cfgs[ ptrC ]. name[ptr] ) ptr++;
      if ( cfgLine[ptr] == '=' )
	{
	  switch ( cfgs[ ptrC ]. type ) {
	    case 1: *(char *)(cfgs[ ptrC ]. p) = cfgLine[ptr + 1] == '1';
	    case 2: *(int *)(cfgs[ ptrC ]. p) = atoi( &cfgLine[ptr + 1] );
	  }
	  ok = 1;
	  break;
	}
      ptrC++;
    }
  if ( !ok ) WaitStatusLine("Invalid line in CONFIG.SHA.");
}

void readConfig()		// precte a nastavi dannou konfiguraci
{
  char str[78];

  strcpy( str, emulDirectory );
  strcat( str, "config.sha" );
  if ( ( cfgHandle = open( str, O_RDONLY | O_BINARY ) ) != -1 )
    {
      cfgEnd = 0;
      while ( !cfgEnd )
	{
	  readCfgLine();		// precti radku
	  if ( cfgLine[0] != 0 )
	    decodeCfgLine();	// zkus dekodovat radku
	}
    }
   else
    WaitStatusLine("I can not find file CONFIG.SHA !!!");
  setupCfg( &cfgDrive );
}
