		.model	large

		.CODE _EMUL

		.386

		extrn	prefix_cb: word
		extrn	prefix_dd: word
		extrn	prefix_ed: word
		extrn	prefix_fd: word
		extrn	prefix_dd_cb: word
		extrn	prefix_fd_cb: word
		extrn	bas_instr: word

		extrn	out_f2: near
		extrn	tinit: near
		extrn	tdone: near
		extrn	mzakt: byte
		extrn	MZGEN4: byte

		locals	@@

	EVEN			; na sudou

af	dw	0
bc	dw	0
de	dw	0
	public	hl
hl	dw	0		; HL
	public	ix
ix	dw	0		; IX
	public	iy
iy	dw	0		; IY

	public	af1
af1	dw	0		; AF'
	public	bc1
bc1	dw	0
	public	de1
de1	dw	0
	public	hl1
hl1	dw	0

spx	dw	0
pcx	dw	0

	EVEN
	public	reg_i
reg_i	db	0
	EVEN
	public	reg_r
reg_r	db	0
	EVEN

		public	one_byte
one_byte	label

	dw	256 dup(0)

; ==========

	EVEN
MEMSTS	dw	0	; status mapy pameti
	EVEN
MODE	db	0	; 0ffh - MZ-800 mod jinak MZ-700 mod
	EVEN
VMODE	db	0	; video mod

;				MZ-800		MZ-700
; bity :	0 - ROM 	0000-0FFF	0000-0FFF
;		1 - CGROM 	1000-2000	1000-2000
;		2 - VRAM        8000-XXXX	C000-D000 (CGRAM)
;		4 - ROM		E000-FFFF	D000-FFFF (od D000 VRAM)

; ==========

		EVEN

seg_RAM		dw	0		; segment RAMky SHARPA (64Kb)
seg_ROM		dw	0		; segment ROMky a VRAM (mapa 48Kb)
seg_VRAM	dw	0		; segment VRAM
bkp_ADR		dw	0		; adresa obsluzne rutiny break pointu
exit_ADR	dw	0, 0		; vystupni adresa z EMULATORU
exit_CODE	dw	0		; vystupni kod

; ============================================
; Tabulka exit_CODE
;
; 1 - chybna instrukce, PC = PC + 1
; 2 - break point
; 3 - chybne nastaveni ridiciho registru 8253
; 4 - u 8253 lze nastavit pouze cteni za letu
; 5 - nemuzu cist z ridiciho slova 8253
; 6 - User break z klavesnice
; 7 - chybne mapovani pameti
; 8 - chybny prikaz pro FDD radic
; 9 - neznamy video mod ...
; 10 - Z80-PIO setup error
; ============================================

_getPtrMSTS	proc
		public	_getPtrMSTS

		mov	dx, cs
		mov	ax, offset MEMSTS
		ret

_getPtrMSTS	endp

SWROM0		proc	near

		push	ax
		push	cx
		push	si
		mov	ds, cs:seg_ROM
		mov	es, cs:seg_RAM
		xor	si, si			; tam zacina
		mov	cx, 100h		; 1000h / 16
SWROM0_1:	mov	ax, [si]
		xchg	ax, es:[si]
		mov	[si], ax
		mov	ax, [si + 2]
		xchg	ax, es:[si + 2]
		mov	[si + 2], ax
		mov	ax, [si + 4]
		xchg	ax, es:[si + 4]
		mov	[si + 4], ax
		mov	ax, [si + 6]
		xchg	ax, es:[si + 6]
		mov	[si + 6], ax
		mov	ax, [si + 8]
		xchg	ax, es:[si + 8]
		mov	[si + 8], ax
		mov	ax, [si + 10]
		xchg	ax, es:[si + 10]
		mov	[si + 10], ax
		mov	ax, [si + 12]
		xchg	ax, es:[si + 12]
		mov	[si + 12], ax
		mov	ax, [si + 14]
		xchg	ax, es:[si + 14]
		mov	[si + 14], ax
		add	si, 16
		loop	SWROM0_1
		mov	es, cs:seg_ROM
		mov	ds, cs:seg_RAM
		pop	si
		pop	cx
		pop	ax
		ret

SWROM0		endp


SWROME		proc	near

		push	ax
		push	cx
		push	si
		mov	ds, cs:seg_ROM
		mov	es, cs:seg_RAM
		mov	si, 2000h		; tam zacina
		mov	cx, 200h		; 2000h / 16
SWROME_1:	mov	ax, [si]
		xchg	ax, es:[si+0c000h]
		mov	[si], ax
		mov	ax, [si + 2]
		xchg	ax, es:[si + 0c002h]
		mov	[si + 2], ax
		mov	ax, [si + 4]
		xchg	ax, es:[si + 0c004h]
		mov	[si + 4], ax
		mov	ax, [si + 6]
		xchg	ax, es:[si + 0c006h]
		mov	[si + 6], ax
		mov	ax, [si + 8]
		xchg	ax, es:[si + 0c008h]
		mov	[si + 8], ax
		mov	ax, [si + 10]
		xchg	ax, es:[si + 0c000h + 10]
		mov	[si + 10], ax
		mov	ax, [si + 12]
		xchg	ax, es:[si + 0c000h + 12]
		mov	[si + 12], ax
		mov	ax, [si + 14]
		xchg	ax, es:[si + 0c000h + 14]
		mov	[si + 14], ax
		add	si, 16
		loop	SWROME_1
		mov	es, cs:seg_ROM
		mov	ds, cs:seg_RAM
		pop	si
		pop	cx
		pop	ax
		ret

SWROME		endp

; ========================================

we_port		proc	near

		pop	bx
		mov	bl, 0
		ret

we_port		endp

		EVEN

re_port		proc	near

		pop	bx
		mov	bl, 0
		ret

re_port		endp

		EVEN

r_e008		proc	near

		mov	bl, cs:frekv_33
		and	bl, 10000001b
		ret

r_e008		endp

; ========================================
;    tabulka pro MZ-700 adresy (porty?)
; ========================================

w_ports7	dw	offset	w_kbd		; 0E000H - zapis na klaves.
		dw	offset	we_port		; 0E001H
		dw	offset	w8255C		; 0E002H
		dw	offset	w8255		; 0E003H
		dw	offset	wctc0		; 0E004H - citac 0 (8253)
		dw	offset	wctc1		; 0E005H - citac 1 (8253)
		dw	offset	wctc2		; 0E006H - citac 2 (8253)
		dw	offset	wcmd8253	; 0E007H - ridici reg. 8253
		dw	offset	we_port		; 0E008H
		dw	offset	we_port		; 0E009H
		dw	offset	we_port		; 0E00AH
		dw	offset	we_port		; 0E00BH
		dw	offset	we_port		; 0E00CH
		dw	offset	we_port		; 0E00DH
		dw	offset	we_port		; 0E00EH
		dw	offset	we_port		; 0E00FH

r_ports7	dw	offset	i_kbd		; 0E000H
		dw	offset	r_kbd		; 0E001H - cteni z klaves.
		dw	offset	inp_8255C	; 0E002H
		dw	offset	we_port		; 0E003H
		dw	offset	rctc0		; 0E004H - citac 0 (8253)
		dw	offset	rctc1		; 0E005H - citac 1 (8253)
		dw	offset	rctc2		; 0E006H - citac 2 (8253)
		dw	offset	rcmd8253	; 0E007H - ridici reg. 8253
		dw	offset	r_e008		; 0E008H
		dw	offset	re_port		; 0E009H
		dw	offset	re_port		; 0E00AH
		dw	offset	re_port		; 0E00BH
		dw	offset	re_port		; 0E00CH
		dw	offset	re_port		; 0E00DH
		dw	offset	re_port		; 0E00EH
		dw	offset	re_port		; 0E00FH

; ========================================
;       Rutiny pro zapis a cteni
; ========================================

		EVEN

WBstd		proc	near

		pop	bx
		mov	ds:[bp], bl
		ret

WBstd		endp

		EVEN

RBstd		proc	near

		mov	bl, ds:[bp]
		ret

RBstd		endp

		EVEN

WWstd		proc	near

		pop	bx
		mov	ds:[bp], bx
		ret

WWstd		endp

		EVEN

RWstd		proc	near

		mov	bx, ds:[bp]
		ret

RWstd		endp

		EVEN

Wrom		proc	near

		pop	bx
		ret

Wrom		endp

		EVEN

RBROM1		proc	near	; cteni ze znakove ROM

		mov	bl, es:[bp]
		ret

RBROM1		endp

		EVEN

RWROM1		proc	near	; cteni ze znakove ROM

		mov	bx, es:[bp]
		ret

RWROM1		endp

		EVEN

WBDNL		proc	near	; zapis do downloadu

		pop	bx
WBDNL_C:	push	bp
		push	ax
		push	dx
		and	bp, 0fffh
		mov	al, bl
		mov	es:[bp + 8000h], al
		add	bp, bp
		mov	bx, bp
		and	bp, 0ff0h
		add	bp, bp
		shl	bh, 2
		and	bx, 400eh
		or	bp, bx
		mov	bl, al
		mov	bh, 0f0h
		mov	bl, es:[bx]
		mov	dx, 3c4h
		mov	ax, 402h		  ; select download
		out	dx, ax
		mov	fs:[bp], bl
		mov	fs:[bp+1], bl
		pop	dx
		pop	ax
		pop	bp
		ret

WBDNL		endp

		EVEN

RBDNL		proc	near	; cteni z downloadu

		mov	bl, es:[bp - 4000h]
		ret

RBDNL		endp

		EVEN

WWDNL		proc	near	; zapis do downloadu

		pop	bx
		push	bx
		call	WBDNL_C
		pop	bx
		mov	bl, bh
		inc	bp
		call	WBDNL_C
		dec	bp
		ret

WWDNL		endp

		EVEN

RWDNL		proc	near	; cteni z downloadu

		mov	bx, es:[bp - 4000h]
		ret

RWDNL		endp

		EVEN

DNLCHNG		db	0

		EVEN

WB7VRAM		proc	near	; zapis do MZ-700 VRAM

		pop	bx
WB7VRAMC:	mov	es:[bp - 9000h], bl	; na 4000h
		test	bp, 400h
		jz	WB7VRAM_1
		ret
WB7VRAM_1:	push	bp
		push	dx
		push	ax
		mov	dx, 3c4h
		test	bp, 800h
		jnz	WB7VRAM_2
		mov	ax, 102h
		out	dx, ax
		pop	ax
		pop	dx
		and	bp, 3ffh
		add	bp, bp
		mov	fs:[bp], bl
		pop	bp
		ret
WB7VRAM_2:	mov	ax, 202h
		out	dx, ax
		pop	ax
		pop	dx
		and	bp, 3ffh
		add	bp, bp
		push	ax
		mov	al, bl
		shr	al, 4
		mov	ah, bl
		shl	ah, 4
		or	al, ah
		and	al, 7fh
		mov	fs:[bp], al
		pop	ax
		pop	bp
		ret

WB7VRAM		endp

		EVEN

RB7VRAM		proc	near

		mov	bl, es:[bp - 9000h]
		ret

RB7VRAM		endp

		EVEN

WW7VRAM		proc	near

		pop	bx
		call	WB7VRAMC	; zapis 1 byte
		push	bx
		mov	bl, bh
		inc	bp
		call	WB7VRAMC	; zapis 2 byte
		dec	bp
		pop	bx
		ret

WW7VRAM		endp

		EVEN

RW7VRAM		proc	near

		mov	bx, es:[bp - 9000h]
		ret

RW7VRAM		endp

		EVEN

WBport7		proc	near		; zapis na porty MZ-700

		pop	bx
WBport7C:	cmp	bp, 0e010h
		jnl	WBport7_1	; pokud neni mensi
		push	bx
		mov	bx, bp
		and	bx, 1111b
		add	bx, bx
		jmp	word ptr cs:[bx + offset w_ports7]
WBport7_1:
;		mov	ds:[bp], bl	; je to prece ROMka ne ?
		ret

WBport7		endp

		EVEN

RBport7		proc	near

RBport7C:	cmp	bp, 0e010h
		jc	RBport7_1
		mov	bl, ds:[bp]
		ret
RBport7_1:	mov	bx, bp
		and	bx, 1111b
		add	bx, bx
		jmp	word ptr cs:[bx + offset r_ports7]

RBport7		endp

		EVEN

WWport7		proc	near

		pop	bx
		call    WBport7C
		push	bx
		mov	bl, bh
		inc	bp
		call	WBport7C
		dec	bp
		pop	bx
		ret

WWport7		endp

		EVEN

RWport7		proc	near

		cmp	bp, 0e10h
		jc	@@1
		mov	bx, ds:[bp]
		ret
@@1:		push	ax
		call	RBport7C
		mov	ah, bl
		inc	bp
		call	RBport7C
		dec	bp
		mov	bh, bl
		mov	bl, ah
		pop	ax
		ret

RWport7		endp

		EVEN

WBVRAM8		proc	near

		db	0bbh		; mov bx, xxx
wvram_a		dw	0
		jmp	bx

WBVRAM8		endp

		EVEN

RBVRAM8		proc	near

		db	0bbh		; mov bx, xxx
rvram_a		dw	0
		jmp	bx

RBVRAM8		endp

		EVEN

WWVRAM8		proc	near

		db	0bbh		; mov bx, xxx
wwvram_a	dw	0
		jmp	bx

WWVRAM8		endp

RWVRAM8		proc	near

		db	0bbh		; mov bx, xxx
wrvram_a	dw	0
		jmp	bx

RWVRAM8		endp

; ========================================

		public	break_p

break_p:	call	store
		mov	cs:exit_CODE, 2		; breakpoint
		jmp	dword ptr cs:exit_ADR

		public	err_instr
err_instr	proc	near

		call	store
		mov	cs:exit_CODE, 1		; chybna instrukce
		jmp	dword ptr cs:exit_ADR

err_instr	endp

error		proc	near		; vyskoceni z emulatoru
					; v BX - exitCode
		call	store
		mov	cs:exit_CODE, bx
		jmp	dword ptr cs:exit_ADR

error		endp

		EVEN

		public	rbyte
rbyte		proc	near

		mov	bx, bp
		mov	bl, bh
		shr	bx, 3
		and	bx, 11110b
		db	2eh			; cs
		db	0ffh, 0a7h
rbyte_a         dw	0

rbyte		endp

		EVEN

		ADRSTART = 01a59h
		ADREND   = 01a63h

		public	wbyte
wbyte		proc	near

		push	bx
		mov	bx, bp
		mov	bl, bh
		shr	bx, 3
		and	bx, 11110b
		db	2eh			; cs
		db	0ffh, 0a7h		; jmp word ptr [bx+ XXX]
wbyte_a		dw	0

wbyte		endp

		EVEN

		public	rword
rword		proc	near

		mov	bx, bp
		mov	bl, bh
		shr	bx, 3
		and	bx, 11110b
		db	2eh		; cs
		db	0ffh, 0a7h
rword_a		dw	0

rword		endp

		EVEN

		public	wword
wword		proc	near

		push	bx
		mov	bx, bp
		mov	bl, bh
		shr	bx, 3
		and	bx, 11110b
		db	2eh		; cs
		db	0ffh, 0a7h
wword_a		dw	0

wword		endp

		public	inpx
inpx		proc	near

		mov	bh, 0
		sub	bl, 0c0h
		jc	inpx_1
		add	bx, bx
		jmp	word ptr cs:[bx + offset inp_tbl]
inpx_1:		ret

inpx		endp

		public	outpx
outpx		proc	near

		push	bx
		mov	bh, 0
		sub	bl, 0c0h
		jc	outpx_1
		add	bx, bx
		jmp	word ptr cs:[bx + offset out_tbl]
outpx_1:	pop	bx
		ret

outpx		endp


; =======================================
;
;     	     P r e f i x y
;
; =======================================

		public	lbl_cb
LBL_CB:	     	mov	bh, 0
		mov	bl, [si+1]
		add	bx, bx
		jmp	word ptr cs:[ bx + offset prefix_cb ]

		public	lbl_dd
LBL_DD:		mov	bh, 0
		mov	bl, [si+1]
		add	bx, bx
		jmp	word ptr cs:[ bx + offset prefix_dd ]

		public	lbl_ed
LBL_ED:		mov	bh, 0
		mov	bl, [si+1]
		add	bx, bx
		jmp	word ptr cs:[ bx + offset prefix_ed ]

		public	lbl_fd
LBL_FD:		mov	bh, 0
		mov	bl, [si+1]
		add	bx, bx
		jmp	word ptr cs:[ bx + offset prefix_fd ]

		public	lbl_dd_cb
LBL_DD_CB:	mov	bh, 0
		mov	bl, [si+3]
		add	bx, bx
		jmp	word ptr cs:[ bx + offset prefix_dd_cb ]

		public	lbl_fd_cb
LBL_FD_CB:	mov	bh, 0
		mov	bl, [si+3]
		add	bx, bx
		jmp	word ptr cs:[ bx + offset prefix_fd_cb ]

		include c:\bc\zdroj\s\i\z801.asm
		include c:\bc\zdroj\s\i\pio.asm
		include	c:\bc\zdroj\s\i\i8253.asm
		include c:\bc\zdroj\s\i\memory.asm
		include c:\bc\zdroj\s\i\kbd.asm
		include c:\bc\zdroj\s\i\inout.asm
		include c:\bc\zdroj\s\i\fdd.asm
		include c:\bc\zdroj\s\i\video.asm
		include c:\bc\zdroj\s\i\8255.asm
		include c:\bc\zdroj\s\i\load.asm
		include c:\bc\zdroj\s\i\rd.asm
		include c:\bc\zdroj\s\i\music.asm

		end
